#!/bin/sh

################################################################################
##                                                                            ##
## Copyright (c) International Business Machines  Corp., 2006                 ##
##                                                                            ##
## This program is free software;  you can redistribute it and#or modify      ##
## it under the terms of the GNU General Public License as published by       ##
## the Free Software Foundation; either version 2 of the License, or          ##
## (at your option) any later version.                                        ##
##                                                                            ##
## This program is distributed in the hope that it will be useful, but        ##
## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
## or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   ##
## for more details.                                                          ##
##                                                                            ##
## You should have received a copy of the GNU General Public License          ##
## along with this program;  if not, write to the Free Software               ##
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA    ##
##                                                                            ##
##                                                                            ##
################################################################################
#
# File:
#   route4-change-dst
#
# Description:
#   Verify the kernel is not crashed when the destination of an IPv4 route is
#   changed frequently
#    test01 - by route command
#    test02 - by ip command
#
# Setup:
#   See ltp-yyyymmdd/testcases/network/stress/README
#
# Author:
#   Mitsuru Chinen <mitch@jp.ibm.com>
#
# History:
#	Mar 16 2006 - Created (Mitsuru Chinen)
#
#-----------------------------------------------------------------------
# Uncomment line below for debug output.
#trace_logic=${trace_logic:-"set -x"}
$trace_logic

# Make sure the value of LTPROOT
LTPROOT=${LTPROOT:-`(cd ../../../../ ; pwd)`}
export LTPROOT

# Total number of the test case
TST_TOTAL=2
export TST_TOTAL

# Default of the test case ID and the test case count
TCID=route4-change-dst
TST_COUNT=0
export TCID
export TST_COUNT

# Check the environmanet variable
source check_envval || exit $TST_TOTAL

# The number of times where route is changed
NS_TIMES=${NS_TIMES:-10000}

# The number of the test link where tests run
LINK_NUM=${LINK_NUM:-0}

# Network portion of the IPv4 address
IPV4_NETWORK="10.0.0"

# Netmask of for the tested network
IPV4_NETMASK="255.255.255.0"
IPV4_NETMASK_NUM=24

# Broadcast address of the tested network
IPV4_BROADCAST=${IPV4_NETWORK}.255

# Host portion of the IPv4 address
LHOST_IPV4_HOST="2"	# src
RHOST_IPV4_HOST="1"	# gateway

# The destination network
DST_NETWORK_PREFIX="10.10"	# destination network would be 10.10.n.0/24
DST_HOST="5"
DST_PORT="7"


#-----------------------------------------------------------------------
#
# NAME:
#   do_setup
#
# DESCRIPTION:
#   Make a IPv4 connectivity
#
# SET VALUES:
#   rhost_ipv4addr	- IPv4 Address of the remote host
#   lhost_ifname	- Interface name of the local host
#   rhost_ifname	- Interface name of the remote host
#
#-----------------------------------------------------------------------
do_setup()
{
    TCID=route4-change-dst
    TST_COUNT=0

    # Initialize the interfaces of the remote host
    initialize_if rhost ${LINK_NUM}

    # Set IPv4 address to the interfaces
    set_ipv4addr rhost ${LINK_NUM} ${IPV4_NETWORK} ${RHOST_IPV4_HOST}
    if [ $? -ne 0 ]; then
	tst_resm TBROK "Failed to add an IPv4 address the remote host"
	exit $TST_TOTAL
    fi

    # IPv4 address of the remote host (gateway)
    rhost_ipv4addr="${IPV4_NETWORK}.${RHOST_IPV4_HOST}"

    # Get the Interface name of local host
    lhost_ifname=`get_ifname lhost ${LINK_NUM}`
    if [ $? -ne 0 ]; then
	tst_resm TBROK "Failed to get the interface name at the local host"
	exit $TST_TOTAL
    fi

    # Get the Interface name of remote host
    rhost_ifname=`get_ifname rhost ${LINK_NUM}`
    if [ $? -ne 0 ]; then
	tst_resm TBROK "Failed to get the interface name at the remote host"
	exit $TST_TOTAL
    fi
}



#-----------------------------------------------------------------------
#
# NAME:
#   do_cleanup
#
# DESCRIPTION:
#   Recover the tested interfaces
#
#-----------------------------------------------------------------------
do_cleanup()
{
    # Initialize the interfaces
    initialize_if lhost ${LINK_NUM}
    initialize_if rhost ${LINK_NUM}
}


#-----------------------------------------------------------------------
#
# FUNCTION:
#   test_body
#
# DESCRIPTION:
#   main code of the test
#
# Arguments:
#   $1: define the test type
#       1 - route command case
#       2 - ip command case
#
#-----------------------------------------------------------------------
de of the/usr/bin/expect' MUST be installed.
#         The home directory of root on the machine exported as "RHOST"
#         should have a ".rhosts" file with the hostname of the machine
#         where the test is executed, OR the "PASSWD" section below MUST
#	  be uncommented and set. 
#
#  HISTORY:
#    03/01 Robbie Williamson (robbiew@us.ibm.com)
#      -Ported
#
# 
# rlogin perform a rlogin session to each host in HOST_LIST with user 
#    RUSER for a count of LOOPCOUNT and does an ls -l /etc/hosts to
#    verify that the rlogin was established.
#
#*********************************************************************

set TC rlogin
set TCtmp "/tmp"
set SLEEPTIME 3
set TESTLOG "$TCtmp"

if [info exists env(RUSER)] {
   set RUSER $env(RUSER)
} else {
   set RUSER root
}

set RHOST $env(RHOST)
set timeout 10

if [info exists env(LOOPCOUNT)] {
   set LOOPCOUNT $env(LOOPCOUNT)
} else {
   set LOOPCOUNT 25
}

# stty echo
send_user " Starting\n"

set count 0
while {$count < $LOOPCOUNT} {
   set count [expr $count+1]
      send_user "Host: $RHOST\n"

      # rlogin to the host
      spawn rlogin $RHOST -l $RUSER
      
      # Uncomment code below and add root's passwd if .rhosts file is not 
      # present on remote host.
      #---------------------------------
      #set PASSWD "<ROOT PASSWORD HERE>"
      #expect -re "Password:"
      #send "$PASSWD\r"

      # Wait for shell prompt
      expect -re "$RUSER@"

      # Run passwd command - and respond to its prompts
      send "LC_ALL=C ls -l /etc/hosts | wc -w > $TESTLOG/$RUSER.$RHOST \r"
      # When shell prompt comes back, logout

      expect -re "$RUSER@"
      exp_send "logout\r"

      send_user "CHECKING RLOGIN STATUS\n"
      set nummatch [exec rsh -n -l $RUSER $RHOST "cat $TESTLOG/$RUSER.$RHOST|grep -c 9"] 
      if {$nummatch==1} {
         send_user "$TC interactive Test Successful in LOOP $count\r"
         exec rsh -n -l $RUSER $RHOST "rm -f $TESTLOG/$RUSER.$RHOST" 
      } else {
         send_user "$TC interactive session FAILED\r"
         exit 1
      }
}

send_user "\nTest PASSES\n\n"
exit 0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       ./usr/lib